using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace rtfhtmlEditor
{
    public partial class FormSpecialChars : Form
    {
        public FormSpecialChars()
        {
            InitializeComponent();
        }

        private void FormSpecialChars_Load(object sender, EventArgs e)
        {
            for (int n = 0; n < System.Drawing.FontFamily.Families.Length; n++)
            {
                this.cbxfontfamily.Items.Add(System.Drawing.FontFamily.Families[n].Name);
            }
            this.cbxfontfamily.SelectedItem = "Microsoft Sans Serif";

            Add_Region("Arabaic", 1536, 1791);
            Add_Region("Arrows", 8592, 8703);
            Add_Region("Basic Latin", 0, 127);
            Add_Region("Currency Symbols", 8352, 8399);
            Add_Region("General Punctuation", 8192, 8303);
            Add_Region("Geometric Shapes", 9632, 9727);
            Add_Region("Greek", 880, 1023);
            Add_Region("Latin-1 Supplement", 128, 255);
            Add_Region("Latin Extended-A", 256, 383);
            Add_Region("Latin Extended-B", 384, 591);
            Add_Region("Letterlike Symbols", 8448, 8527);
            Add_Region("Mathematical Operators", 8704, 8959);
            Add_Region("Miscellaneous Technical", 8960, 9215);
            Add_Region("Miscellaneous Symbols", 9728, 9983);
            Add_Region("Spacing Modifier Letters", 688, 767);

            this.cbxcategory.SelectedIndex = 2;
        }

        private void Add_Region(string Region_Name, int Region_Start, int Region_End)
        {
            DataSetCharacters.Table_CharactersRow newrow = this.dataSetCharacters1.Table_Characters.NewTable_CharactersRow();
            newrow[this.dataSetCharacters1.Table_Characters.Range_NameColumn.ColumnName] = Region_Name;
            newrow[this.dataSetCharacters1.Table_Characters.Range_StartColumn.ColumnName] = Region_Start;
            newrow[this.dataSetCharacters1.Table_Characters.Range_EndColumn.ColumnName] = Region_End;
            this.dataSetCharacters1.Table_Characters.AddTable_CharactersRow(newrow);
        }


        private void btnOK_Click(object sender, EventArgs e)
        {
            this.listView1.Focus();
            FormEdit frmEdit = (FormEdit)this.Owner;
            this.label1.Text = this.label1.Text + this.listView1.SelectedItems[0].Text;
            frmEdit.htmlRichTextBox1.Focus();
            frmEdit.htmlRichTextBox1.SelectionFont = new Font(this.listView1.Font.FontFamily, (float)8.25);
            frmEdit.htmlRichTextBox1.SelectedText = this.listView1.SelectedItems[0].Text;
        }

        private void cbxfontfamily_SelectedIndexChanged(object sender, EventArgs e)
        {
            string stringfamily = this.cbxfontfamily.SelectedItem.ToString();
            Font nFont = new Font(stringfamily, this.listView1.Font.Size);
            this.listView1.Font = nFont;
            this.label1.Font = new Font(nFont.FontFamily, (float)8.25);
        }

        protected override void OnClosing(CancelEventArgs e)
        {
            this.label1.Text = "";
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.cbxcategory.SelectedIndex != -1)
            {
                this.listView1.Items.Clear();
                System.Data.DataRowView selected_row = (System.Data.DataRowView)this.cbxcategory.SelectedValue;
                for (int n = (int)selected_row[1]; n < (int)selected_row[2]; n++)
                {
                    char cr = (char)n;
                    if (!Char.IsWhiteSpace(cr))
                    {
                        string add_char = Convert.ToString(cr);
                        ListViewItem litem = new ListViewItem(add_char, 0);
                            this.listView1.Items.Add(litem);
                    }
                }
            }

        }
    }
}